﻿local addonName, addon = ...

if not Bartender4 then
	error(addonName .. " could not load, missing dependency: Bartender4")
elseif not ImpliedTarget then
	error(addonName .. " could not load, missing dependency: ImpliedTarget")
end

local LAB = LibStub('LibActionButton-1.0', true)
if not LAB then
	error(addonName .. " could not load, missing dependency: LibActionButton-1.0")
end

local AddButton, RemoveButton = ImpliedTarget.AddButton, ImpliedTarget.RemoveButton

-- Bartender4 handles paging for the primary action bar so remove it from ImpliedTarget
ImpliedTarget.DisablePaging()

-- Bartender4 remaps key binds already so remove it from ImpliedTarget
ImpliedTarget.DisableKeyBinding()

-- Bartender4 makes all new action buttons and hides the defaults so remove them from ImpliedTarget
for id = 1, NUM_ACTIONBAR_BUTTONS do
	RemoveButton('ActionButton' .. id)
	RemoveButton('ExtraActionButton' .. id)
	RemoveButton('MultiBarBottomLeftButton' .. id)
	RemoveButton('MultiBarBottomRightButton' .. id)
	RemoveButton('MultiBarLeftButton' .. id)
	RemoveButton('MultiBarRightButton' .. id)
end

for id = 1, NUM_OVERRIDE_BUTTONS or NUM_ACTIONBAR_BUTTONS do
	RemoveButton('OverrideActionBarButton' .. id)
end

-- Add Bartender4's action buttons
for button in pairs(LAB:GetAllButtons()) do
	local name = button:GetName()
	if name and name:match("^BT4Button%d+$") then
		AddButton(button)
	end
end

LAB.RegisterCallback(addon, 'OnButtonCreated', function(event, button)
	local name = button:GetName()
	if name and name:match("^BT4Button%d+$") then
		AddButton(button)
	end
end)
